# IAX2FullFrameVoice Class Reference

`#include <frame.h>`

Inheritance diagram for IAX2FullFrameVoice:

[legend]
Collaboration diagram for IAX2FullFrameVoice:
[legend]

## Public Types

| g7231 = 1
| gsm = 2
| g711ulaw = 4
| g711alaw = 8
| mp3 = 0x10
| adpcm = 0x20
| pcm = 0x40
| lpc10 = 0x80
| g729 = 0x100
| speex = 0x200
| ilbc = 0x400
| supportedCodecs = 11
enum | AudioSc { g7231 = 1, gsm = 2, g711ulaw = 4, g711alaw = 8, mp3 = 0x10, adpcm = 0x20, pcm = 0x40, lpc10 = 0x80, g729 = 0x100, speex = 0x200, ilbc = 0x400, supportedCodecs = 11 }

## Public Member Functions

| IAX2FullFrameVoice (const IAX2Frame &srcFrame)
| IAX2FullFrameVoice (const IAX2FullFrame &srcFrame)
| IAX2FullFrameVoice (IAX2CallProcessor *processor, PBYTEArray &sound, PINDEX usersTimeStamp=0)
virtual | ~IAX2FullFrameVoice ()
virtual PString | GetSubClassName () const
virtual BYTE | GetFullFrameType ()

## Static Public Member Functions

static PString | GetSubClassName (unsigned testValue)
static PString | GetOpalNameOfCodec (PINDEX testValue)
static unsigned short | OpalNameToIax2Value (const PString opalName)

## Detailed Description

Used for transmitting voice packets in a relaible fashion. Typically, one is sent at the start of the call, and then at regular intervals in the call to keep the timestamps in sync.

This class has the ability to build audio codecs, and report on available formats.

The contents the data section is the compressed audio frame.

## Member Enumeration Documentation

enum IAX2FullFrameVoice::AudioSc

enum comtaining the possible (uncompressed) subclass value for these voice frames

Enumerator:

  g7231 | G.723.1 audio format in this frame
  gsm | GSM audio format in this frame
  g711ulaw | G.711 uLaw audio format in this frame
  g711alaw | G.711 ALaw audio format in this frame
  mp3 | MPeg 3 audio format in this frame
  adpcm | ADPCM audio format in this frame
  pcm | PCM audio format in this frame
  lpc10 | LPC10 audio format in this frame
  g729 | G.729 audio format in this frame
  speex | Speex audio format in this frame
  ilbc | ILBC audio format in this frame
  supportedCodecs | The number of codecs defined by this enum

## Constructor & Destructor Documentation

IAX2FullFrameVoice::IAX2FullFrameVoice | ( | const IAX2Frame & | srcFrame | ) |

Construction from a supplied dataframe. In this case, this class is filled from an incoming data packet

IAX2FullFrameVoice::IAX2FullFrameVoice | ( | const IAX2FullFrame & | srcFrame | ) |

Construction from a supplied dataframe. In this case, this class is filled from an incoming data packet

IAX2FullFrameVoice::IAX2FullFrameVoice | ( | IAX2CallProcessor * | processor,
|  | PBYTEArray & | sound,
|  | PINDEX | usersTimeStamp = `0` |
| ) |  |  |

Construction from an encoded audio array (stored in a PBYTEArray), in preparation to sending to remote node. The constructor will not delete the supplied PBYTEArray structure.

The full frame will use the specified timeStamp, if it is > 0. If the specified timeStamp == 0, the timeStamp will be calculated from when the call started.

virtual IAX2FullFrameVoice::~IAX2FullFrameVoice | ( |  | ) | `[virtual]`

Declare an empty destructor

## Member Function Documentation

virtual BYTE IAX2FullFrameVoice::GetFullFrameType | ( |  | ) | `[inline, virtual]`

Return the IAX2FullFrame type represented here (voice, protocol, session etc

Reimplemented from IAX2FullFrame.

static PString IAX2FullFrameVoice::GetOpalNameOfCodec | ( | PINDEX | testValue | ) | `[static]`

Get text description of the subclass contents, given the supplied argument. The name returned is that recoginised by the OPAL library.

static PString IAX2FullFrameVoice::GetSubClassName | ( | unsigned | testValue | ) | `[static]`

Get text description of the subclass contents, given the supplied argument

virtual PString IAX2FullFrameVoice::GetSubClassName | ( |  | ) | const`[virtual]`

Get text description of the subclass contents

Reimplemented from IAX2FullFrame.

static unsigned short IAX2FullFrameVoice::OpalNameToIax2Value | ( | const PString | opalName | ) | `[static]`

Turn the OPAL string (which describes the codec) into a AudioSc value. If there is no conversion found, return 0.

The documentation for this class was generated from the following file:

- frame.h